/* file:	src/osgVRPN/AnalogTransform.cpp
 * author:	Mike Weiblen mew@mew.cx 2003-12-27
 * copyright:	(C) 2003 Michael Weiblen
 * license:	OpenSceneGraph Public License (OSGPL)
*/

// #include <cassert>
#include <osg/Notify>
#include <osgVRPN/AnalogTransform.h>

using namespace osgVRPN;

// TODO add a feature to rotate the Analog into the view orientation.

///////////////////////////////////////////////////////////////////////////

class AnalogUpdateCallback : public osg::NodeCallback
{
    virtual void operator()( osg::Node* node, osg::NodeVisitor* nv )
    {
	AnalogTransform* xform = dynamic_cast<AnalogTransform*>( node );
	osg::ref_ptr<Analog> analog = xform->getAnalog();
	if( analog.valid() )
	{
	    analog->update();
	    xform->setMatrix( analog->getMatrix() );
	}

	traverse(node,nv);
    }
};


///////////////////////////////////////////////////////////////////////////

AnalogTransform::AnalogTransform( osg::ref_ptr<Analog> analog )
{
    setAnalog( analog );
    setUpdateCallback( new AnalogUpdateCallback );
}

AnalogTransform::AnalogTransform( const char* analogName )
{
    setAnalog( new Analog( analogName ) );
    setUpdateCallback( new AnalogUpdateCallback );
}

/*EOF*/
